=== modified file 'cmenu.ui'
--- cmenu.ui	2007-05-14 17:20:33 +0000
+++ cmenu.ui	2007-05-18 16:01:10 +0000
@@ -23,4 +23,9 @@
         <menuitem name="diff_selected" action="diff_selected" />
         <menuitem name="diff_all" action="diff_all" />
     </popup>
+    <popup name="context_remote">
+        <menuitem name="view_remote" action="view_remote" />
+        <menuitem name="diff_remote" action="diff_remote" />
+        <menuitem name="revert_remote" action="revert_remote" />
+    </popup>
 </ui>

=== modified file 'olive.glade'
--- olive.glade	2007-05-17 16:54:02 +0000
+++ olive.glade	2007-05-18 16:01:10 +0000
@@ -1,4 +1,4 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE glade-interface SYSTEM "glade-2.0.dtd">
 <!--*- mode: xml -*-->
 <glade-interface>
@@ -575,6 +575,7 @@
                         <property name="label" translatable="yes">H_istory Mode</property>
                         <property name="use_underline">True</property>
                         <property name="draw_indicator">True</property>
+                        <signal name="toggled" handler="on_checkbutton_history_toggled"/>
                       </widget>
                       <packing>
                         <property name="expand">False</property>
@@ -589,6 +590,7 @@
                         <property name="sensitive">False</property>
                         <property name="can_focus">True</property>
                         <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
+                        <signal name="key_press_event" handler="on_entry_history_revno_key_press_event"/>
                       </widget>
                       <packing>
                         <property name="expand">False</property>
@@ -1272,6 +1274,167 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_location_repobranch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_cobranch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_repoco">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_coroot">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">5</property>
+                        <property name="bottom_attach">6</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_branchroot">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">6</property>
+                        <property name="bottom_attach">7</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_sharedrepo">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_lightcoroot">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_coroot_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Checkout root: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">5</property>
+                        <property name="bottom_attach">6</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_branchroot_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Branch root: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">6</property>
+                        <property name="bottom_attach">7</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_repoco_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Repository checkout: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_cobranch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Checkout of branch: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_repobranch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Repository branch: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_location_sharedrepo_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Shared repository: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_location_lightcoroot_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Light checkout root: </property>
@@ -1281,167 +1444,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Shared repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout of branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository checkout: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_lightcoroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -1477,6 +1479,42 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_related_parentbranch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_related_publishbranch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_related_publishbranch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Publish to branch: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_related_parentbranch_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Parent branch: </property>
@@ -1486,42 +1524,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Publish to branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_parentbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -1557,6 +1559,92 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_format_control">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_workingtree">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_branch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_repository">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_repository_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Repository format: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_branch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Branch format: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_format_workingtree_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Working tree format: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_format_control_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Control format: </property>
@@ -1566,92 +1654,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Working tree format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_control">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -1687,6 +1689,67 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_locking_workingtree">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_locking_branch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_locking_repository">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_locking_repository_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Repository lock status: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_locking_branch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Branch lock status: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_locking_workingtree_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Working tree lock status: </property>
@@ -1696,67 +1759,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -1792,6 +1794,42 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_missing_workingtree">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_missing_branch">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_missing_branch_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Missing revisions in branch: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_missing_workingtree_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Missing revisions in working tree: </property>
@@ -1801,42 +1839,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Missing revisions in branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -1872,6 +1874,192 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_unchanged">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_modified">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_added">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_removed">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_renamed">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_unknown">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">5</property>
+                        <property name="bottom_attach">6</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_ignored">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">6</property>
+                        <property name="bottom_attach">7</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_subdirs">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">7</property>
+                        <property name="bottom_attach">8</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_subdirs_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Versioned subdirectories: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">7</property>
+                        <property name="bottom_attach">8</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_ignored_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Ignored files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">6</property>
+                        <property name="bottom_attach">7</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_unknown_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Unknown files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">5</property>
+                        <property name="bottom_attach">6</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_renamed_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Renamed files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_removed_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Removed files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_added_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Added files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_wtstats_modified_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Modified files: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_wtstats_unchanged_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Unchanged files: </property>
@@ -1881,192 +2069,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Modified files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Added files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Removed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Renamed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Unknown files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Ignored files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Versioned subdirectories: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unchanged">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -2102,6 +2104,117 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_brstats_revno">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_commiters">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_age">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_firstrev">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_lastrev">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_lastrev_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Time of last revision: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">4</property>
+                        <property name="bottom_attach">5</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_firstrev_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Time of first revision: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">3</property>
+                        <property name="bottom_attach">4</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_age_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Age of branch in days: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">2</property>
+                        <property name="bottom_attach">3</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_brstats_commiters_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Number of commiters: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_brstats_revno_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Revisions in branch: </property>
@@ -2111,117 +2224,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Number of commiters: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Age of branch in days: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of first revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of last revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_revno">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>
@@ -2257,6 +2259,42 @@
                     <property name="n_columns">2</property>
                     <property name="column_spacing">12</property>
                     <child>
+                      <widget class="GtkLabel" id="label_info_repstats_revisions">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_repstats_size">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">(none)</property>
+                      </widget>
+                      <packing>
+                        <property name="left_attach">1</property>
+                        <property name="right_attach">2</property>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
+                      <widget class="GtkLabel" id="label_info_repstats_size_label">
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Size of repository: </property>
+                      </widget>
+                      <packing>
+                        <property name="top_attach">1</property>
+                        <property name="bottom_attach">2</property>
+                        <property name="x_options">GTK_FILL</property>
+                        <property name="y_options"></property>
+                      </packing>
+                    </child>
+                    <child>
                       <widget class="GtkLabel" id="label_info_repstats_revisions_label">
                         <property name="xalign">0</property>
                         <property name="label" translatable="yes">Revisions in repository: </property>
@@ -2266,42 +2304,6 @@
                         <property name="y_options"></property>
                       </packing>
                     </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Size of repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_revisions">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
                   </widget>
                 </child>
               </widget>

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2007-05-17 16:12:27 +0000
+++ olive/__init__.py	2007-05-18 16:01:10 +0000
@@ -53,6 +53,7 @@
 from bzrlib.plugins.gtk.conflicts import ConflictsDialog
 from bzrlib.plugins.gtk.initialize import InitDialog
 from bzrlib.plugins.gtk.push import PushDialog
+from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
 
 class OliveGtk:
     """ The main Olive GTK frontend class. This is called when launching the
@@ -117,6 +118,11 @@
         self.entry_location = self.toplevel.get_widget('entry_location')
         self.image_location_error = self.toplevel.get_widget('image_location_error')
         
+        # Get the History widgets
+        self.check_history = self.toplevel.get_widget('checkbutton_history')
+        self.entry_history = self.toplevel.get_widget('entry_history_revno')
+        self.button_history = self.toplevel.get_widget('button_history_browse')
+        
         self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
         
         # Dictionary for signal_autoconnect
@@ -160,7 +166,10 @@
                 "on_treeview_left_row_activated": self.on_treeview_left_row_activated,
                 "on_button_location_up_clicked": self.on_button_location_up_clicked,
                 "on_button_location_jump_clicked": self.on_button_location_jump_clicked,
-                "on_entry_location_key_press_event": self.on_entry_location_key_press_event
+                "on_entry_location_key_press_event": self.on_entry_location_key_press_event,
+                "on_checkbutton_history_toggled": self.on_checkbutton_history_toggled,
+                "on_entry_history_revno_key_press_event": self.on_entry_history_revno_key_press_event,
+                "on_button_history_browse_clicked": self.on_button_history_browse_clicked
             }
         
         # Connect the signals to the handlers
@@ -202,48 +211,30 @@
         self.remote = False
         self.remote_branch = None
         self.remote_path = None
+        self.remote_revision = None
         
         self.set_path(os.getcwd())
         self._load_right()
         
         self._just_started = False
 
-    def set_path(self, path):
+    def set_path(self, path, force_remote=False):
         self.notbranch = False
         
-        if os.path.isdir(path):
-            self.image_location_error.destroy()
-            self.remote = False
-            
-            # We're local
-            try:
-                self.wt, self.wtpath = WorkingTree.open_containing(path)
-            except (bzrerrors.NotBranchError, bzrerrors.NoWorkingTree):
-                self.notbranch = True
-            
-            # If we're in the root, we cannot go up anymore
-            if sys.platform == 'win32':
-                drive, tail = os.path.splitdrive(path)
-                if tail in ('', '/', '\\'):
-                    self.button_location_up.set_sensitive(False)
-                else:
-                    self.button_location_up.set_sensitive(True)
-            else:
-                if self.path == '/':
-                    self.button_location_up.set_sensitive(False)
-                else:
-                    self.button_location_up.set_sensitive(True)
-        elif not os.path.isfile(path):
-            # Doesn't seem to be a file nor a directory, trying to open a
-            # remote location
+        if force_remote:
+            # Forcing remote mode (reading data from inventory)
             self._show_stock_image(gtk.STOCK_DISCONNECT)
             try:
                 br = Branch.open_containing(path)[0]
             except bzrerrors.NotBranchError:
                 self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
+                self.check_history.set_active(False)
+                self.check_history.set_sensitive(False)
                 return False
             except bzrerrors.UnsupportedProtocol:
                 self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
+                self.check_history.set_active(False)
+                self.check_history.set_sensitive(False)
                 return False
             
             self._show_stock_image(gtk.STOCK_CONNECT)
@@ -253,7 +244,10 @@
             # We're remote
             self.remote_branch, self.remote_path = Branch.open_containing(path)
             
-            self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).entries()
+            if self.remote_revision is None:
+                self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).entries()
+            else:
+                self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_revision).entries()
             
             if len(self.remote_path) == 0:
                 self.remote_parent = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).iter_entries_by_dir().next()[1].file_id
@@ -270,6 +264,79 @@
                 self.button_location_up.set_sensitive(False)
             else:
                 self.button_location_up.set_sensitive(True)
+        else:
+            if os.path.isdir(path):
+                self.image_location_error.destroy()
+                self.remote = False
+                
+                # We're local
+                try:
+                    self.wt, self.wtpath = WorkingTree.open_containing(path)
+                except (bzrerrors.NotBranchError, bzrerrors.NoWorkingTree):
+                    self.notbranch = True
+                
+                # If we're in the root, we cannot go up anymore
+                if sys.platform == 'win32':
+                    drive, tail = os.path.splitdrive(path)
+                    if tail in ('', '/', '\\'):
+                        self.button_location_up.set_sensitive(False)
+                    else:
+                        self.button_location_up.set_sensitive(True)
+                else:
+                    if self.path == '/':
+                        self.button_location_up.set_sensitive(False)
+                    else:
+                        self.button_location_up.set_sensitive(True)
+            elif not os.path.isfile(path):
+                # Doesn't seem to be a file nor a directory, trying to open a
+                # remote location
+                self._show_stock_image(gtk.STOCK_DISCONNECT)
+                try:
+                    br = Branch.open_containing(path)[0]
+                except bzrerrors.NotBranchError:
+                    self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
+                    self.check_history.set_active(False)
+                    self.check_history.set_sensitive(False)
+                    return False
+                except bzrerrors.UnsupportedProtocol:
+                    self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
+                    self.check_history.set_active(False)
+                    self.check_history.set_sensitive(False)
+                    return False
+                
+                self._show_stock_image(gtk.STOCK_CONNECT)
+                
+                self.remote = True
+               
+                # We're remote
+                self.remote_branch, self.remote_path = Branch.open_containing(path)
+                
+                if self.remote_revision is None:
+                    self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).entries()
+                else:
+                    self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_revision).entries()
+                
+                if len(self.remote_path) == 0:
+                    self.remote_parent = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).iter_entries_by_dir().next()[1].file_id
+                else:
+                    for (name, type) in self.remote_entries:
+                        if name == self.remote_path:
+                            self.remote_parent = type.file_id
+                            break
+                
+                if not path.endswith('/'):
+                    path += '/'
+                
+                if self.remote_branch.base == path:
+                    self.button_location_up.set_sensitive(False)
+                else:
+                    self.button_location_up.set_sensitive(True)
+        
+        if self.notbranch:
+            self.check_history.set_active(False)
+            self.check_history.set_sensitive(False)
+        else:
+            self.check_history.set_sensitive(True)
         
         self.statusbar.push(self.context_id, path)
         self.entry_location.set_text(path)
@@ -290,6 +357,32 @@
         from bzrlib.plugins.gtk.dialog import about
         about()
         
+    
+    def on_button_history_browse_clicked(self, widget):
+        """ Browse for revision button handler. """
+        if self.remote:
+            br = self.remote_branch
+        else:
+            br = self.wt.branch
+            
+        revb = RevisionBrowser(br, self.window)
+        response = revb.run()
+        if response != gtk.RESPONSE_NONE:
+            revb.hide()
+        
+            if response == gtk.RESPONSE_OK:
+                if revb.selected_revno is not None:
+                    self.entry_history.set_text(revb.selected_revno)
+            
+            revb.destroy()
+    
+    def on_button_location_jump_clicked(self, widget):
+        """ Location Jump button handler. """
+        location = self.entry_location.get_text()
+        
+        if self.set_path(location):
+            self.refresh_right()
+    
     def on_button_location_up_clicked(self, widget):
         """ Location Up button handler. """
         if not self.remote:
@@ -304,12 +397,31 @@
 
         self.refresh_right()
     
-    def on_button_location_jump_clicked(self, widget):
-        """ Location Jump button handler. """
-        location = self.entry_location.get_text()
-        
-        if self.set_path(location):
-            self.refresh_right()
+    def on_checkbutton_history_toggled(self, widget):
+        """ History Mode toggle handler. """
+        if self.check_history.get_active():
+            # History Mode activated
+            self.entry_history.set_sensitive(True)
+            self.button_history.set_sensitive(True)
+        else:
+            # History Mode deactivated
+            self.entry_history.set_sensitive(False)
+            self.button_history.set_sensitive(False)
+    
+    def on_entry_history_revno_key_press_event(self, widget, event):
+        """ Key pressed handler for the history entry. """
+        if event.keyval == 65293:
+            # Return was hit, so we have to load that specific revision
+            # Emulate being remote, so inventory should be used
+            path = self.get_path()
+            if not self.remote:
+                self.remote = True
+                self.remote_branch = self.wt.branch
+            
+            revno = int(self.entry_history.get_text())
+            self.remote_revision = self.remote_branch.get_rev_id(revno)
+            if self.set_path(path, True):
+                self.refresh_right()
     
     def on_entry_location_key_press_event(self, widget, event):
         """ Key pressed handler for the location entry. """
@@ -650,8 +762,12 @@
                 m_annotate.set_sensitive(False)
                 m_diff.set_sensitive(False)
 
-            menu.right_context_menu().popup(None, None, None, 0,
-                                            event.time)
+            if not self.remote:
+                menu.right_context_menu().popup(None, None, None, 0,
+                                                event.time)
+            else:
+                menu.remote_context_menu().popup(None, None, None, 0,
+                                                 event.time)
         
     def on_treeview_right_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the

=== modified file 'olive/menu.py'
--- olive/menu.py	2007-05-14 17:20:33 +0000
+++ olive/menu.py	2007-05-18 16:01:10 +0000
@@ -111,7 +111,19 @@
                                       ('diff_all', None,
                                        _('All...'), None,
                                        _('Show the differences of all files'),
-                                       self.diff_all)
+                                       self.diff_all),
+                                      ('view_remote', None,
+                                       _('View contents'), None,
+                                       _('View the contents of the file in a builtin viewer'),
+                                       self.view_remote),
+                                      ('diff_remote', None,
+                                       _('Show differences'), None,
+                                       _('Show the differences between two revisions of the file'),
+                                       self.diff_remote),
+                                      ('revert_remote', None,
+                                       _('Revert to this revision'), None,
+                                       _('Revert the selected file to the selected revision'),
+                                       self.revert_remote)
                                      ])
         
         self.ui.insert_action_group(self.actiongroup, 0)
@@ -120,6 +132,7 @@
         self.cmenu_right = self.ui.get_widget('/context_right')
         self.cmenu_left = self.ui.get_widget('/context_left')
         self.toolbar_diff = self.ui.get_widget('/toolbar_diff')
+        self.cmenu_remote = self.ui.get_widget('/context_remote')
         
         # Set icons
         # TODO: do it without using deprecated comm
@@ -142,6 +155,9 @@
     def left_context_menu(self):
         return self.cmenu_left
     
+    def remote_context_menu(self):
+        return self.cmenu_remote
+    
     @show_bzr_error
     def add_file(self, action):
         """ Right context menu -> Add """
@@ -325,3 +341,15 @@
         from diff import OliveDiff
         diff = OliveDiff(self.comm)
         diff.display()
+    
+    def view_remote(self, action):
+        """ Remote context menu -> View contents """
+        print "DEBUG: view contents."
+    
+    def diff_remote(self, action):
+        """ Remote context menu -> Show differences """
+        print "DEBUG: show differences."
+    
+    def revert_remote(self, action):
+        """ Remote context menu -> Revert to this revision """
+        print "DEBUG: revert to this revision."

